import 'dart:async';

import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:wyatt_ui_components/wyatt_wyatt_ui_components.dart';

class ButtonCubit extends Cubit<ControlState> {
  ButtonCubit() : super(ControlState.normal);

  FutureOr<void> onMouseEnter() async {
    if (state == ControlState.disabled) {
      return;
    }
    emit(ControlState.hovered);
  }

  FutureOr<void> onMouseLeave() async {
    if (state == ControlState.disabled) {
      return;
    }
    emit(ControlState.normal);
  }

  FutureOr<void> onFocus() async {
    if (state == ControlState.disabled) {
      return;
    }
    emit(ControlState.focused);
  }

  FutureOr<void> onUnfocus() async {
    if (state == ControlState.disabled) {
      return;
    }
    emit(ControlState.normal);
  }

  FutureOr<void> onClickDown() async {
    if (state == ControlState.disabled) {
      return;
    }
    emit(ControlState.tapped);
  }

  FutureOr<void> onClickUpIn() async {
    if (state == ControlState.disabled) {
      return;
    }
    emit(ControlState.hovered);
  }

  FutureOr<void> onClickUpOut() async {
    if (state == ControlState.disabled) {
      return;
    }
    emit(ControlState.normal);
  }

  FutureOr<void> disable() async {
    emit(ControlState.disabled);
  }

  FutureOr<void> enable() async {
    emit(ControlState.normal);
  }
}
